<?php

   
class colorEditorWindow extends tileEditorWindow
{
   protected $wbEv;
   
   protected $windowTitle;
   protected $tileX, $tileY;
   protected $bankimg;
   protected $tileTable;
   protected $window;
   protected $selectedElement;
   protected $colorArr, $chrrom, $tileNames;
   protected $nameList, $numberBox, $tileFrame, $bankFrame;
   
   function __construct($windowTitle)
   {  
      $this->wbEv =& $GLOBALS['wbEvents'];            
      $this->windowTitle = $windowTitle;   
      
      
   }

   function initWindow()
   {
      
      
   }


   
   function createWindow()
   {  $wbEv =& $this->wbEv;
      $rom =& $wbEv->rom;   
      $em = $wbEv->em;
      
      
      $size = (3 * 2) * 2;
      $mainWindow =& $wbEv->mainWindow;
      $wbEv->createWindowEvent(array($this,'windowHandler'),
         $this->window = wb_create_window(  
            $mainWindow->getWindow(), ModelessDialog  , $this->windowTitle, 
               $this->window[0], $this->window[1], 26 + (4 * 16) + $em * 12 + 10 + 256, ($em * 10) + ($em * 12) + 56, 
                  WBC_NOTIFY, WBC_DBLCLICK | WBC_MOUSEDOWN | WBC_MOUSEUP));
      
      $window =& $this->window;
      
      $this->nameList = wb_create_control(
         $window, ListBox, '', 10, $em  * 12 + 20,26 + (4 * 16) + $em * 12 + 10 + 256 - 25, $em*10, 
            $wbEv->createEvent(array($this,'listBoxEvent')));
      
      $this->numberBox = wb_create_control(
         $window, EditBox, '', 26 + (4 * 16), 10, $em * 10, $em  * 12, 
            $wbEv->createEvent(array($this,'numberBoxEvent')), WBC_MULTILINE , 0, 0);
      
      $this->frame = wb_create_control(
         $window, Frame, '', 10, 10, 16 * 4,  12 * $em, 
            ID, WBC_IMAGE);
      
      $this->paletteFrame = wb_create_control(
         $window, Frame, "", 26 + (4 * 16) + $em * 10 + 16 ,10, 256, 4 * 16, 
            ID, WBC_IMAGE);
            
      $pal = $rom->buildNESPalette();
      $pal_resized = Freeimage_Rescale($pal, 16 * 16, 4 * 16);
      drawFreeimage($this->paletteFrame, $pal_resized);
      
      
      $this->colorGroups = $rom->getColorGroups();
      
      $colorGroupNames = array();
      foreach ($this->colorGroups as $n=>$v)
      {  $colorGroupNames[] = $v[0];
      }
      wb_set_text($this->nameList,$colorGroupNames);
         
      wb_set_selected($this->nameList, 0); 
                 
   }      
   
   
   
   function numberBoxEvent($params)
   {    
      $wbEv =& $this->wbEv;
      $rom =& $wbEv->rom;
      
      $str = wb_get_text($this->numberBox);
      $str = preg_replace('%\s%s', '', $str);
      
      //toConsole(" $this->size == ". strlen($str)."[$str]");
      $bytelen = $this->size;
      if (strlen($str) == $bytelen  * 2)
      {  //toConsole($str.'--');
         $tilearr = array();
         $bytes = '';
         for($i = 0;$i < $bytelen; $i++)
         {  
            $tilearr[$i] = hexdec(substr($str,$i*2,2));
            $bytes  .= chr($tilearr[$i]);
         }
        
         if ($this->selectedElement !== false)
         {  
            
            $colorGroupRow = $this->colorGroups[$this->selectedElement]; 
            $loc = $rom->getMemoryLoc($colorGroupRow[1]);
            $rom->seekTo($loc[0]);            
            $rom->putBytes($bytes);
            
            $wbEv->playerColors = $rom->getColors('PlayerColors', 12 , 1);
            $wbEv->colors = $rom->getColors('GroundAreaColors'); 
            
            $windows = array($wbEv->marioEditor, $wbEv->enemyEditor, $wbEv->metatileEditor);
            foreach ($windows as $n => $v)
            {  $v->updateColors();
            }
            
            $this->listBoxEvent($params,true);
         }
      }
   }
   

   function listBoxEvent($params, $notext = false)
   {  $wbEv =& $this->wbEv;
      $rom =& $wbEv->rom;
      
      $this->selectedElement = wb_get_selected($this->nameList);
      
      $result = $this->processListBox($this->selectedElement);
      
      $pal = $rom->buildNESPalette($result[0], $result[1],$result[2]);
      $this->palX = $result[1];
      $this->palY = $result[2];
      
      $black = $rom->buildNESPalette(array(0x30), 1,1);         
      $black = resizeFreeimage($black, 4, 8);
      FreeImage_Paste($black,$pal,0,0);
      FreeImage_Unload($pal);
      
      drawFreeimage($this->frame, resizeFreeimage($black, 16 * 4, 12 * $wbEv->em));              
      
      if (!$notext)
      {  wb_set_text($this->numberBox,$result[3]);
      }
      
      
   }
   
   
   function processListBox($selectedEl)
   {  $wbEv =& $this->wbEv;
      $rom =& $wbEv->rom;
      
      $colorGroupRow = $this->colorGroups[$selectedEl];      
      $loc = $rom->getMemoryLoc($colorGroupRow[1]);
      $rom->seekTo($loc[0]);
      $this->size = $loc[1];
      
      $str = $rom->getBytes($this->size);
      
      $tilearr = array();
      $numberText = '';
      
      $counter = 0;
      for($i = 0;$i < $colorGroupRow[3]; $i++)
      {  for($j = 0;$j < $colorGroupRow[2]; $j++)
         {  
            $tilearr[$counter] = ord(substr($str,$counter,1));
            $numberText .= str_pad(dechex($tilearr[$counter]),2,'0',STR_PAD_LEFT) . ' ';
            $counter++;
         }
         $numberText .= "\n";
         
      }      
      $numberText = substr($numberText,0,-1);
      return array($tilearr, $colorGroupRow[2],  $colorGroupRow[3], $numberText);
   }
   

}

?>