<?php

function FreeImage_Copy(&$dib, $topx, $topy, $botx, $boty)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_Copy", $FI);
	$ret = wb_call_function($pfn, array($dib, $topx, $topy, $botx, $boty));

   return $ret;
}

function FreeImage_Paste(&$dst, &$src, $left = 0 , $top = 0, $alpha = 256)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_Paste", $FI);
	return wb_call_function($pfn, array($dst, $src, $left, $top, $alpha));
}

function FreeImage_Clone(&$dib, $topx, $topy, $botx, $boty)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_Clone", $FI);
	return wb_call_function($pfn, array($dib));
}

function FreeImage_OpenMemory($mem, $len)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_OpenMemory", $FI);
	return wb_call_function($pfn, array($mem, $len));
	
}

function FreeImage_CloseMemory( & $mem)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_CloseMemory", $FI);
	return wb_call_function($pfn, array($mem));
}

function FreeImage_LoadFromMemory($type, & $mem, $flags = 0)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_LoadFromMemory", $FI);
	return wb_call_function($pfn, array($type, $mem, $flags));
}



function FreeImage_SwapColors(&$dib,  $color_a,  $color_b, $ignore_alpha = false)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_SwapColors", $FI);
	return wb_call_function($pfn, array($dib,  wb_get_address($color_a), wb_get_address($color_b), ignore_alpha));
}



function FreeImage_ConvertTo4Bits(&$dib)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_ConvertTo4Bits", $FI);
	return wb_call_function($pfn, array($dib));
}


function & FreeImage_ConvertFromRawBits( $bits,  $width, $height, $pitch, $bpp, $redmask = 0, $greenmask = 0 , $bluemask  = 0, $topdown = false)
{
	global $FI;
	static $pfn = null;

	if($pfn === null)
		$pfn = wb_get_function_address("FreeImage_ConvertFromRawBits", $FI);
	$ret = wb_call_function($pfn, array(wb_get_address($bits),  $width, $height, $pitch, $bpp, $redmask, $greenmask, $bluemask, $topdown));


	
	return $ret;
}


function freeimage_to_wb(&$dib, $destroy = false)
{

   $width = FreeImage_GetWidth($dib);                      // Get its dimensions
   $height = FreeImage_GetHeight($dib);
   $ret = wb_create_image($width, $height, 
                          FreeImage_GetInfoHeader($dib),  FreeImage_GetBits($dib));
   if ($destroy)
   {  Freeimage_unload($dib);
   }
   return $ret;
}

function wb_to_freeimage(&$image, $destroy = true)
{  $pixeldata = wb_get_image_data($image);
   $size = wb_get_size($image);
   $dib = FreeImage_Allocate($size[0],$size[1] , 32);
   wb_poke(FreeImage_GetBits($dib), $pixeldata);   
   
   if ($destroy)
   {  wb_destroy_image($image);
   }
   return $dib;
}

function wb_copy_image(&$image)
{  $tmpfi = wb_to_Freeimage($image);
   return Freeimage_to_wb($tmpfi, true);     
   
}


function wb_draw_image_copy(&$target, &$img, $x=0,$y=0 , $width=0, $height=0,$color=null)
{  $newimg = wb_copy_image($img);
   wb_draw_image($target, $newimg , $x, $y,$width,$height, $color);
   wb_destroy_image($newimg);
}


function & FreeImage_LoadVar($type,  $var)
{
   
   $imgstream = FreeImage_OpenMemory($var,strlen($var)); 
   $img = FreeImage_LoadFromMemory($type,$imgstream); 
   FreeImage_CloseMemory($imgstream);
   return $img;
}



function drawFreeimage($frame, $img, $destroy = true)
{
   wb_set_image($frame, $tempimg = freeimage_to_wb($img, $destroy));
   wb_destroy_image($tempimg);
}

function resizeFreeimage($img, $x, $y)
{
   
   $newimg = Freeimage_Rescale($img, $x, $y);
   Freeimage_Unload($img);
   return $newimg;
}

?>