<?php

class SMBrom extends nesfile
{    
   function RAMtoROM($ram)
   {  return ($ram - 0x7ff0);
   }
   
   function ROMtoRAM($ram)
   {  return ($ram + 0x7ff0);
   }
   
   function getMetatileNames()
   {  return $this->metatileNames;
   }
   
   function getMarioNames()
   {  return $this->MarioNames;
   }
   
   function getEnemyNames()
   {  return $this->EnemyNames;
   }
   
   function getColorGroups()
   {  return $this->ColorGroups;
   }

   function getMemoryLoc($name)
   {  return $this->memoryLoc[$name];
   }
      
   function getMemoryBlock($name)
   {  
      $this->seekTo($this->memoryLoc[$name][0]);
      return $this->getBytes($this->memoryLoc[$name][1]);
   }  
   
   function seekToMemoryBlock($name)
   {  $this->seekTo($this->memoryLoc[$name][0]);
   }
   
   function getColors($name, $amount = 8, $backgroundNum = false, $specialColors = false)
   {  if ($backgroundNum === false)
      {                  
         $areaBGOffset = array(  'WaterAreaColors',
                                 'GroundAreaColors',
                                 'UndergroundAreaColors',
                                 'CastleAreaColors',
                                 'NightColors',
                                 'DaySnowColors',
                                 'NightSnowColors',
                                 'CastleSnowColors',
                              );
         $areaBGOffset = array_flip($areaBGOffset);                                                    
         $backgroundNum = $areaBGOffset[$name];                                     
      }
      
      $backgrounds = $this->getMemoryBlock('BackgroundColors');
      $bg = substr($backgrounds, $backgroundNum, 1);             
      
                       
      $this->seekToMemoryBlock($name);            
      
      $ret = array();
      
      for ($colorSet = 0; $colorSet < $amount; $colorSet++)
      {  $ret[$colorSet] = array();
         
         for ($color = 0; $color < 4; $color++)   
         {   $ret[$colorSet][$color] = ord($this->getBytes(1));
         } 
         $ret[$colorSet][0] = ord($bg);  
      }     
      return $ret;
      
   }   
   // data constants
   private $memoryLoc = array(
                        'MetatileGraphicsOffsets' => array(0x0b18, 8),
                        'MetatileGraphicsTable' => array(0x0b20, 404),

                        'MarioGraphicsTable' => array(0x6e27, 208),

                        'EnemyGraphicsTable' => array(0x674e, 258),
                        'EnemyGfxTableOffsets' => array(0x6850, 27),
                        'EnemyAttributeData' => array(0x686b, 27),                        
                        
                        'BackgroundColors' => array(0x05df, 8),
                        'PlayerColors' => array(0x05e7, 12),
                        'CoinRotateColors' => array(0x09d3, 6),
                        'Pal3Data' => array(0x09e1, 12),
                        'WaterAreaColors' => array(0x0cb7, 32),
                        'GroundAreaColors' => array(0x0cdb, 32),
                        'UndergroundAreaColors' => array(0x0cff, 32),
                        'CastleAreaColors' => array(0x0d23, 32),
                        'DaySnowColors' => array(0x0d47, 4),
                        'NightSnowColors' => array(0x0d4f, 4),
                        'MushroomColors' => array(0x0d57, 4),
                        'BowserColors' => array(0x0d5f, 4),
                        
                        
                       );
                       
   private $metatileNames = array(  "Blank",
                                    "Black Metatile",
                                    "Bush Left",
                                    "Bush Middle",
                                    "Bush Right",
                                    "Mountain Left",
                                    "Mountain Left Bottom/Middle Center",
                                    "Mountain Middle Top",
                                    "Mountain Right",
                                    "Mountain Right Bottom",
                                    "Mountain Middle Bottom",
                                    "Bridge Guardrail",
                                    "Chain",
                                    "Tall Tree Top, Top Half",
                                    "Short Tree Top",
                                    "Tall Tree Top, Bottom Half",
                                    "Warp Pipe End Left, Points Up",
                                    "Warp Pipe End Right, Points Up",
                                    "Decoration Pipe End Left, Points Up",
                                    "Decoration Pipe End Right, Points Up",
                                    "Pipe Shaft Left",
                                    "Pipe Shaft Right",
                                    "Tree Ledge Left Edge",
                                    "Tree Ledge Middle",
                                    "Tree Ledge Right Edge",
                                    "Mushroom Left Edge",
                                    "Mushroom Middle",
                                    "Mushroom Right Edge",
                                    "Sideways Pipe End Top",
                                    "Sideways Pipe Shaft Top",
                                    "Sideways Pipe Joint Top",
                                    "Sideways Pipe End Bottom",
                                    "Sideways Pipe Shaft Bottom",
                                    "Sideways Pipe Joint Bottom",
                                    "Seaplant",
                                    "Blank, Used On Bricks Or Blocks That Are Hit",
                                    "Flagpole Ball",
                                    "Flagpole Shaft",
                                    "Blank, Used In Conjunction With Vines",
                                    "Vertical Rope",
                                    "Horizontal Rope",
                                    "Left Pulley",
                                    "Right Pulley",
                                    "Blank Used For Balance Rope",
                                    "Castle Top",
                                    "Castle Window Left",
                                    "Castle Brick Wall",
                                    "Castle Window Right",
                                    "Castle Top W/ Brick",
                                    "Entrance Top",
                                    "Entrance Bottom",
                                    "Green Ledge Stump",
                                    "Fence",
                                    "Tree Trunk",
                                    "Mushroom Stump Top",
                                    "Mushroom Stump Bottom",
                                    "Breakable Brick W/ Line",
                                    "Breakable Brick",
                                    "Breakable Brick (Not Used)",
                                    "Cracked Rock Terrain",
                                    "Brick With Line (Power-Up)",
                                    "Brick With Line (Vine)",
                                    "Brick With Line (Star)",
                                    "Brick With Line (Coins)",
                                    "Brick With Line (1-Up)",
                                    "Brick (Power-Up)",
                                    "Brick (Vine)",
                                    "Brick (Star)",
                                    "Brick (Coins)",
                                    "Brick (1-Up)",
                                    "Hidden Block (1 Coin)",
                                    "Hidden Block (1-Up)",
                                    "Solid Block (3-D Block)",
                                    "Solid Block (White Wall)",
                                    "Bridge",
                                    "Bullet Bill Cannon Barrel",
                                    "Bullet Bill Cannon Top",
                                    "Bullet Bill Cannon Bottom",
                                    "Blank Used For Jumpspring",
                                    "Half Brick Used For Jumpspring",
                                    "Solid Block (Water Level, Green Rock)",
                                    "Half Brick (???)",
                                    "Water Pipe Top",
                                    "Water Pipe Bottom",
                                    "Flag Ball (Residual Object)",
                                    "Cloud Left",
                                    "Cloud Middle",
                                    "Cloud Right",
                                    "Cloud Bottom Left",
                                    "Cloud Bottom Middle",
                                    "Cloud Bottom Right",
                                    "Water/Lava Top",
                                    "Water/Lava",
                                    "Cloud Level Terrain",
                                    "Bowser's Bridge",
                                    "Question Block (Coin)",
                                    "Question Block (Power-Up)",
                                    "Coin",
                                    "Underwater Coin",
                                    "Empty Block",
                                    "Axe");
                                    
   private $MarioNames = array(     "Big Player Walking Frame 1",
                                    "Big Player Walking Frame 2",
                                    "Big Player Walking Frame 3",
                                    "Big Player Skidding",
                                    "Big Player Jumping",
                                    "Big Player Swimming Frame 1",
                                    "Big Player Swimming Frame 2",
                                    "Big Player Swimming Frame 3",
                                    "Big Player Climbing Frame 1",
                                    "Big Player Climbing Frame 2",
                                    "Big Player Crouching",
                                    "Big Player Fireball Throwing",
                                    "Small Player Walking Frame 1",
                                    "Small Player Walking Frame 2",
                                    "Small Player Walking Frame 3",
                                    "Small Player Skidding",
                                    "Small Player Jumping",
                                    "Small Player Swimming Frame 1",
                                    "Small Player Swimming Frame 2",
                                    "Small Player Swimming Frame 3",
                                    "Small Player Climbing Frame 1",
                                    "Small Player Climbing Frame 2",
                                    "Small Player Killed",
                                    "Small Player Standing",
                                    "Intermediate Grow Frame",
                                    "Big Player Standing");
                                    
   private $EnemyNames = array(     "Buzzy Beetle Frame 1",
                                    "Buzzy Beetle Frame 2",
                                    "Koopa Troopa Frame 1",
                                    "Koopa Troopa Frame 2",
                                    "Koopa Paratroopa Frame 1",
                                    "Koopa Paratroopa Frame 2",
                                    "Spiny Frame 1",
                                    "Spiny Frame 2",
                                    "Spiny's Egg Frame 1",
                                    "Spiny's Egg Frame 2",
                                    "Bloober Frame 1",
                                    "Bloober Frame 2",
                                    "Cheep-Cheep Frame 1",
                                    "Cheep-Cheep Frame 2",
                                    "Goomba",
                                    "Koopa Shell Frame 1 (Upside-Down)",
                                    "Koopa Shell Frame 2",
                                    "Koopa Shell Frame 1 (Rightsideup)",
                                    "Koopa Shell Frame 2",
                                    "Buzzy Beetle Shell Frame 1 (Rightsideup)",
                                    "Buzzy Beetle Shell Frame 2",
                                    "Buzzy Beetle Shell Frame 1 (Upside-Down)",
                                    "Buzzy Beetle Shell Frame 2",
                                    "Defeated Goomba",
                                    "Lakitu Frame 1",
                                    "Lakitu Frame 2",
                                    "Princess",
                                    "Mushroom Retainer",
                                    "Hammer Bro Frame 1",
                                    "Hammer Bro Frame 2",
                                    "Hammer Bro Frame 3",
                                    "Hammer Bro Frame 4",
                                    "Piranha Plant Frame 1",
                                    "Piranha Plant Frame 2",
                                    "Podoboo",
                                    "Bowser Front Frame 1",
                                    "Bowser Rear Frame 1",
                                    "Bowser Front Frame 2",
                                    "Bowser Rear Frame 2",
                                    "Bullet Bill",
                                    "Jumpspring Frame 1",
                                    "Jumpspring Frame 2",
                                    "Jumpspring Frame 3");   
   
   private $ColorGroups = array(
                                 array('Background Colors','BackgroundColors', 4,2),
                                 array('Player Palettes','PlayerColors' , 4, 3),
                                 array('Rotating Coin Colors','CoinRotateColors', 3, 2),
                                 array('Coin Color Palettes','Pal3Data', 4, 3),
                                 array('Water Area Palette','WaterAreaColors', 4, 8),
                                 array('Overworld Area Palette','GroundAreaColors', 4, 8),
                                 array('Underground Area Palette','UndergroundAreaColors', 4, 8),
                                 array('Castle Area Palette','CastleAreaColors', 4, 8),
                                 array('Daytime Snow Palette','DaySnowColors', 4, 1),
                                 array('Nighttime Snow Palette ','NightSnowColors', 4, 1),
                                 array('Mushroom Platform Palette','MushroomColors', 4, 1),
                                 array('Bowser Palette','BowserColors', 4, 1),
                               );
}

?>
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 