<?php

/**
 *  wbEventHandler v0.2
 *  by frantik 2008
 *  
 *  Light framework for handling events within WinBinder
 *
 */


class wbEventHandler
{
   private $controls = array();
   private $windows = array();
   private $counter = 1000;   
      
   
   // adds existing window to event handler
   public function createWindowEvent($handler, $window)
   {  wb_set_handler($window, '__wbEventHandler'); 
            
      $this->windows[$window] = $handler;

   }
   
   // Adds existing control to event handler, generates ID
   // returns ID     
   public function createEvent($functionName)
   {  $this->controls[$this->counter] = $functionName;
      return $this->counter++;
   }
                                    
   // handles event calls (called by __wbEventHandler)
   public function eventHandler($window, $id, $ctrl, $param1, $param2)
   {  
      $params = array('window'=>$window, 'id'=>$id, 'ctrl'=>$ctrl, 'param1'=>$param1, 'param2'=>$param2, 'mouse'=>false, 'wbEvents' => $this);
		   
      // Generate some extra data about the mouse
      if ($id == IDDEFAULT)      
      {  $params['mouse'] = array('buttons' => array( 'LBUTTON' => false,
                                                      'RBUTTON' => false,
                                                      'MBUTTON' => false,
                                                      'CONTROL' => false,
                                                      'SHIFT'   => false,
                                                      'ALT'     => false));
                                       
         
         if($param1 & WBC_LBUTTON)
			{ 	$params['mouse']['buttons']['LBUTTON'] = true;
		   }
			if($param1 & WBC_RBUTTON)
			{ 	$params['mouse']['buttons']['RBUTTON'] = true;
		   }
		   if($param1 & WBC_MBUTTON)
			{ 	$params['mouse']['buttons']['MBUTTON'] = true;
		   }
			if($param1 & WBC_ALT)
			{ 	$params['mouse']['buttons']['ALT'] = true;
		   }
			if($param1 & WBC_CONTROL)
			{ 	$params['mouse']['buttons']['CONTROL'] = true;
		   }
			if($param1 & WBC_SHIFT)
			{ 	$params['mouse']['buttons']['SHIFT'] = true;
		   }
		   
         $params['mouse']['xpos'] = $param2 & 0xFFFF;
	      $params['mouse']['ypos'] = ($param2 & 0xFFFF0000) >> 16;
                  
	   }
	   	 
	   $ret = false; 
      if (array_key_exists($id, $this->controls) && is_callable($this->controls[$id]))      
      {  return call_user_func_array($this->controls[$id],array($params));
      }

      else if (array_key_exists($window, $this->windows) && is_callable($this->windows[$window]))      
      {  $ret = call_user_func_array($this->windows[$window],array($params));
      }
      
      /**
       * If window handler function doesn't return true, close window on IDCLOSE
       * this ensures windows always close when the 'X' is clicked, unless
       * the programmer stop it by returning true.  it is assumed the 
       * programmer will handle the close call when returning true.
       *
       */      
  
      if ($ret !== true && ($id == IDCLOSE))
      {                        
         wb_destroy_window($window);
      }
      return $ret;
       
   }      
   
   // prevents accidental cloning
   public function __clone()
   {
      trigger_error('Clone of wbEvents is not allowed.  Copy by reference only.', E_USER_ERROR);
   }
   // end class declaration
}

function __wbEventHandler($window, $id, $ctrl, $param1, $param2)
{
   global $wbEvents;
   $wbEvents->eventHandler($window, $id, $ctrl, $param1, $param2);
   
}
           
$wbEvents = new wbEventHandler;

?>